//
//  maxlib.h
//
//  Created by Orly Natan on 22/11/17.
//


#ifndef maxlib_h
#define maxlib_h

#include "firmatalib.h"

#define TOTAL_IN_PINS       20
#define TOTAL_OUT_PINS      12

#define DEFAUTLT_BAUD       57600
#define MAX_PORTS           20

#define IN_BOARD            0
#define OUT_BOARD           1

#define PIN_OFFSET          6  

typedef struct {
    
    // pins representation of ARDUINO board
    // object for both reading (in) and writing (out)
    board_t *board;

    char *name;
    int name_len;

    void *board_in;
    void *board_out;

    
} board_mgr_t;


board_t* maxclient_newboard(char *name, int baud, char *err);
void maxclient_setconfig(int *config);

// connect to board via a serial port, init board to desired configuration
// and start listening to updates from the board
int maxclient_connect(board_t *board, int len_config, int *pins, int *modes, int funct);
int maxclient_disconnect(board_t *board);

void maxclient_listen(board_t *board);

// restart listening to board after pausing (unchanged configuration)
void maxclient_restart();

// stop communication with the board via the serial port and disconnect
void maxclient_stop(board_t *board);

// pause (ignore) board updates
void maxclient_pause();

void maxclient_toggleDigital(board_t *board, int pin, int newVal);
void maxclient_moveServo(board_t *board, int pin, int newVal);
void maxclient_movePwm(board_t *board, int pin, int newVal);
void maxclient_toggleListener(board_t *board);
void maxclient_getInputValues(board_t *board, int *indexArray,int *valuesArray, int pinsCount);
void maxclient_listenerOn(void);
void maxclient_listenerOff(void);
void maxclient_configurePins(board_t *board, int len_config, int *pins, int *modes);
int maxclient_shutdown(board_t *board);

#endif /* maxlib_h */
